<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8">
    <link href="https://brendan.ie/main.css" rel="stylesheet">

    <title>Brendan's UL Timetable Stuff</title>

    <meta content="Brendan's UL Timetable Stuff" name="title">
    <meta content="Brendan Golden" name="author">
    <meta content="Brendan's tools for timetable.ul.ie" name="description">

    <!-- for mobile devices -->
    <meta content="width=device-width,initial-scale=1" name="viewport">

    <!-- brendan.coffee -->
    <link href="https://brendan.ie/coffee/coffee.css" rel="stylesheet">
    <script src="https://brendan.ie/coffee/coffee.js"></script>
  </head>
  <body class="sticky-wrapper">
    <div id="coffee_anchor"><span id="served"></span></div>
    <script>C0FFEE()</script>
    <header>
      <h1>Brendan's UL Timetable Stuff</h1>
    </header>
    <main>
      <p>
        Just some tools related to timetable.ul.ie
      </p>
      <hr/>
      <h3><a href="./calendar">Timetable to ical</a></h3>
      <p>
        Convert the calendar that UL gives ye into a format you can plonk into Outlook.
        <br />
        Customisable reminders and naming scheme
      </p>
      <hr/>
      <h3><a href="./rooms">Free Rooms</a></h3>
      <p>
        Find free rooms on campus.
        <br />
        Empty rooms are useful for study/groupwork.
        <br />
        I dont recommend using them for video calls, book a room instead.
      </p>
      <hr/>
      <h3><a href="./rooms_building">Free Rooms (building)</a></h3>
      <p>
        Same as above but broken down per building.
        <br />
        Also visually shows when a room is free
      </p>
      <hr/>
      <h3><a href="./modules">Modules Builder (???)</a></h3>
      <p>
        Enter one or more modules and see where the free time is.
        <br />
        Can also break it down to individual weeks
      </p>
    </main>
    <footer>
      <span>
          © 2021-<span id="year">2021</span> | <wbr/>
          Brendan Golden | <wbr/>
          Email: contact_me(at symbol)brendan.ie <a href="mailto:contact_website@brendan.ie"></a><a href="mailto:contact@brendan.ie"></a>  | <wbr/>
          Gitlab: <a href="https://gitlab.com/Brendan_Golden">Brendan_Golden</a> | <wbr/>
          Discord: Silver#5563 | <wbr/>
          Mastodon: <a rel="me" href="https://mastodon.brendan.ie/@silver">@silver</a>
        </span>
    </footer>

    <script>
      /* I am a lazy fucker */
      document.getElementById('year').textContent = new Date().getFullYear().toString()
    </script>
    <script>
      function toggleRemainderTime(){
        let container = document.getElementById('reminder_time_container');
        container.hidden = !container.hidden;
      }

      async function sendData () {
        let url = `https://api.brendan.ie/timetable/calendar`+
          `?ical_session_id=${document.getElementById('session_id').value}`+
          `&ical_forms_auth=${document.getElementById('forms_auth').value}`+
          `&ical_type=${document.getElementById('type').value}`+
          `&ical_codes=${document.getElementById('codes').value}`+
          `&ical_reminder_toggle=${document.getElementById('reminder_toggle').value}`+
          `&ical_reminder_time=${document.getElementById('reminder_time').value}`

        await fetch(url)
          // get the data
          .then(async (response) => {
            if (response.status === 400) {
              document.getElementById(`info`).innerText = await response.text()
            }
            if (response.status === 204) {
              document.getElementById(`info`).innerText = 'Either no classes or invalid details'
            }

            return response.blob()
          })
          // https://stackoverflow.com/a/9834261/11964934
          .then(blob => {
            if (blob.size === 0) {
              return
            }

            // looks like this creates an invisible link then clicks it
            const url = window.URL.createObjectURL(blob)
            const a = document.createElement('a')
            a.style.display = 'none'
            a.href = url
            a.download = 'brendan.ie_ul_calendar.ics'
            document.body.appendChild(a)
            a.click()
            window.URL.revokeObjectURL(url)

          }).catch((err) => console.log(err))
      }
    </script>
  </body>
</html>